unsigned char up_p = 0,left_p = 0,right_p = 0,down_p = 0,scnd_p = 0,diam_p = 0,shift_p = 0,alpha_p = 0;
// Wait_For_Millis was written by Thomas Nussbaumer

#ifndef WAIT_FOR_MILLIS_C
#define WAIT_FOR_MILLIS_C

/*===========================================================================*/
/* "waits" a given number of milliseconds (dummy looping)                    */
/* NOTE: this wait loop is parametrized to fit on HW1 calculators            */
/*===========================================================================*/

asm("xdef __waitms
__waitms:  movem.l %d0-%d3,-(%sp)
           move.w (20,%sp),%d2
           move.l #31,%d1
           move.l #31,%d3
_wl2_:     move.w #120,%d0    /* modify this value for exact timing !!! */
_wl1_:     rol.l  %d3,%d1
           dbra   %d0,_wl1_
           dbra   %d2,_wl2_
           movem.l (%sp)+,%d0-%d3
           rts");


#define WaitForMillis __waitms
void WaitForMillis(unsigned short);

#endif

// end of Thomas' code

unsigned char ngetdelay(unsigned short delay) {
	unsigned int bay = 0;
	up_p = 0;
	left_p = 0;
	right_p = 0;
	down_p = 0;
	scnd_p = 0;
	diam_p = 0;
	shift_p = 0;
	alpha_p = 0;
	WaitForMillis(delay);
	while (1) {
		bay = _rowread(~((short)(1 << 0)));
		if (bay & (1 << 0)) up_p = 1;  // up
		if (bay & (1 << 1)) left_p = 1;// left
		if (bay & (1 << 2)) down_p = 1; // down
		if (bay & (1 << 3)) right_p = 1; // right
		if (bay & (1 << 4)) scnd_p = 1;  // 2nd
		if (bay & (1 << 5)) shift_p = 1;  // shift
		if (bay & (1 << 6)) diam_p = 1;  // diamond
		if (bay & (1 << 7)) alpha_p = 1;  // alpha
		bay = _rowread(~((short)(1 << 1)));
		if (bay & (1 << 0)) return 44; // enter
		if (bay & (1 << 1)) return 40; // plus
		if (bay & (1 << 2)) return 35; // minus
		if (bay & (1 << 3)) return 30; // multiply
		if (bay & (1 << 4)) return 25; // divide
		if (bay & (1 << 5)) return 20; // ^
		if (bay & (1 << 6)) return 15; // clear
		if (bay & (1 << 7)) return 4;  // f5
		bay = _rowread(~((short)(1 << 2)));
		if (bay & (1 << 0)) return 43; // negate
		if (bay & (1 << 1)) return 39; // 3
		if (bay & (1 << 2)) return 34; // 6
		if (bay & (1 << 3)) return 29; // 9
		if (bay & (1 << 4)) return 24; // ,
		if (bay & (1 << 5)) return 19; // T
		if (bay & (1 << 6)) return 14; // <-
		if (bay & (1 << 7)) return 3;  // f4
		bay = _rowread(~((short)(1 << 3)));
		if (bay & (1 << 0)) return 42; // .
		if (bay & (1 << 1)) return 38; // 2
		if (bay & (1 << 2)) return 33; // 5
		if (bay & (1 << 3)) return 28; // 8
		if (bay & (1 << 4)) return 23; // )
		if (bay & (1 << 5)) return 18; // z
		if (bay & (1 << 6)) return 13; // catalog
		if (bay & (1 << 7)) return 2;  // f3
		bay = _rowread(~((short)(1 << 4)));
		if (bay & (1 << 0)) return 41; // 0
		if (bay & (1 << 1)) return 37; // 1
		if (bay & (1 << 2)) return 32; // 4
		if (bay & (1 << 3)) return 27; // 7
		if (bay & (1 << 4)) return 22; // (
		if (bay & (1 << 5)) return 17; // y
		if (bay & (1 << 6)) return 12; // mode
		if (bay & (1 << 7)) return 1;  // f2
		bay = _rowread(~((short)(1 << 5)));
		if (bay & (1 << 0)) return 10; // apps
		if (bay & (1 << 1)) return 36; // ->
		if (bay & (1 << 2)) return 31; // EE
		if (bay & (1 << 3)) return 26; // |
		if (bay & (1 << 4)) return 21; // =
		if (bay & (1 << 5)) return 16; // x
		if (bay & (1 << 6)) return 11; // home
		if (bay & (1 << 7)) return 0;  // f1
		bay = _rowread(~((short)(1 << 6)));
		if (bay & (1 << 0)) return 7; // esc
		if (up_p || left_p || right_p || down_p || scnd_p || diam_p || shift_p || alpha_p) return 255;
	}
}

INT_HANDLER save_int_1 = 0,save_int_5 =0;

void Disable_int(void) {
	save_int_1 = GetIntVec(AUTO_INT_1);
	save_int_5 = GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
  SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
  return;
}

void Reenable_int(void) {
	SetIntVec(AUTO_INT_1, save_int_1);
	SetIntVec(AUTO_INT_5, save_int_5);
	return;
}
